\documentclass[11pt]{beamer}
\usepackage[utf8]{inputenc}
\usepackage{algorithm}
\usepackage{algorithmic}
\usepackage{listings}

\lstset{language=C, basicstyle=\tiny, frame=single, breaklines=true, numbers=left, tabsize=2, numberstyle=\tiny, morekeywords={}}
\setbeamertemplate{footline}[frame number]

\title{Présentation de Yarn \\ ~ \\ Projet HPC Cloud}
\date{10 décembre 2018}
\author{Nathalie Furmento}% \and Gérald Point \\ \texttt{prenom.nom@labri.fr}}
\usetheme{Madrid}
\begin{document}
\setbeamercovered{dynamic}

\begin{frame}[plain]
  \titlepage
\end{frame}

\begin{frame}{Yarn}
  \begin{itemize}
  \item introduit dans Hadoop 2
  \item sépare la problématique de la gestion des ressources des
    clusters de celle du traitement des données
  \item permet
    \begin{itemize}
      \item différentes interactions avec les données stockées sur le
        cluster (en batch, de façon interactive, en analysant les flux
        au fil de leur réception ou autre)
      \item et simultanément, sans qu'une application ou une requête
        se mette à consommer toutes les ressources du cluster.
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}{Historique - Hadoop v1.0}
  \includegraphics[width=\linewidth]{pictures/MapReduce-Version-1-0-Hadoop-YARN-Edureka-1}
  {\tiny \copyright{\url{https://www.edureka.co/blog/hadoop-yarn-tutorial/}}}
\end{frame}

\begin{frame}{Hadoop v2.0}
  \includegraphics[width=\linewidth]{pictures/Hadoop-v1-0-vs-Hadoop-v2-0}
  {\tiny \copyright{\url{https://www.edureka.co/blog/hadoop-yarn-tutorial/}}}
\end{frame}

\begin{frame}[allowframebreaks]{YARN Architecture}
  \includegraphics[width=\linewidth]{pictures/Components-of-YARN-1}
  {\tiny \copyright{\url{https://www.edureka.co/blog/hadoop-yarn-tutorial/}}}

  \framebreak

  \begin{description}
    \item[Resource Manager] Runs on a master daemon and manages the resource allocation in the cluster.
    \item[Node Manager] They run on the slave daemons and are responsible for the execution of a task on every single Data Node.
    \item[Application Master] Manages the user job lifecycle and resource needs of individual applications. It works along with the Node Manager and monitors the execution of tasks.
    \item[Container] Package of resources including RAM, CPU, Network, HDD etc on a single node.
  \end{description}
\end{frame}

\begin{frame}{Resource Manager}
  \begin{itemize}
    \item decides the allocation of the available resources for competing applications.
    \item Optimizes the cluster utilization like keeping all resources in use all the time against various constraints such as capacity guarantees, fairness, and SLAs.
    \item Two components
      \begin{enumerate}
      \item Scheduler: allocating resources to the various running
        applications, no guarantee to restart the failed tasks,
        pluggable partititioning policy plug-in,
      \item Application Manager: accept job submission, execute and
        restart on failure the application specific Application Master.
      \end{enumerate}
  \end{itemize}

\end{frame}

\begin{frame}{Resource Reservation}
  \begin{itemize}
    \item ReservationSystem : component that allows users to specify a
      profile of resources over-time and temporal constraints (e.g.,
      deadlines), and reserve resources to ensure the predictable
      execution of important jobs.
      \item Tracks resources over-time, performs admission control for
        reservations, and dynamically instruct the underlying
        scheduler to ensure that the reservation is fullfilled.
  \end{itemize}
\end{frame}

\begin{frame}{Application Submission in YARN}
  \begin{columns}
    \begin{column}{0.65\textwidth}
      \includegraphics[width=\linewidth]{pictures/Application-Submission-Hadoop-YARN-Edureka}
      {\tiny \copyright{\url{https://www.edureka.co/blog/hadoop-yarn-tutorial/}}}
    \end{column}
    \begin{column}{0.35\textwidth}
      \begin{enumerate}
      \item<1-> Submit the job
      \item<2-> Get Application ID
      \item<3-> Application Submission Context
      \item<4-> a) Start Container Launch \\ b) Launch Application Master
      \item<5-> Allocate Resources
      \item<6-> a) Container \\ b) Launch
      \item<7-> Execute
      \end{enumerate}
    \end{column}
  \end{columns}
\end{frame}

\begin{frame}{Application Workflow in Hadoop YARN}
      \includegraphics[width=\linewidth]{pictures/Application-Workflow-Hadoop-YARN-Edureka}
      {\tiny \copyright{\url{https://www.edureka.co/blog/hadoop-yarn-tutorial/}}}

      \only<1>{1. Client submits an application}
      \only<2>{2. Resource Manager allocates a container to start Application Manager}
      \only<3>{3. Application Manager registers with Resource Manager}
      \only<4>{4. Application Manager asks containers from Resource Manager}
      \only<5>{5. Application Manager notifies Node Manager to launch containers}
      \only<6>{6. Application code is executed in the container}
      \only<7>{7. Client contacts Resource Manager/Application Manager to monitor application’s status}
      \only<8>{8. Application Manager unregisters with Resource Manager}
\end{frame}

\begin{frame}[allowframebreaks]{MPI and Yarn}
  \begin{itemize}
  \item MR+ \url{https://www.open-mpi.org/video/mrplus/Greenplum_RalphCastain-1up.pdf}
    \begin{itemize}
      \item Port of Hadoop’s MR classes to the general computing environment
      \item Allow jobs using the Hadoop MapReduce API to be run under Open MPI.
    \end{itemize}
  \item MPJ Express \url{https://core.ac.uk/display/81954217}
    \begin{itemize}
    \item MPI-like — implements the mpiJava 1.2 API — messaging library
    \item Integrated with YARN to allow executing parallel Java
      applications on a Hadoop cluster.
    \item \url{http://mpjexpress.org/}
    \item \url{http://mpjexpress.org/docs/guides/yarnguide.pdf}
    \end{itemize}

    \framebreak

  \item HAMSTER \url{https://pivotalhd-210.docs.pivotal.io/doc/2100/webhelp/topics/Hamster.html}
    \begin{itemize}
    \item support MPI applications on YARN,
    \end{itemize}

  \item GERBIL \url{http://people.cs.vt.edu/~butta/docs/ccgrid2015-gerbil.pdf}
    \begin{itemize}
    \item a YARN-based framework for transparently co-hosting
      unmodified MPI applications alongside MapReduce applications
      on the same set of resources.
    \item supports user-specified task allocation strategies,
      e.g., optimizing for minimum job wait time, inter-process locality,
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}{MPICH-YARN}
  \url{https://github.com/alibaba/mpich2-yarn}
  \begin{itemize}
  \item application running on Hadoop YARN that enables MPI
    programs to run on Hadoop YARN clusters.
  \item uses MPICH-3.1.2 as implementation of MPI and uses ssh as
    communication daemon.
    \pause
  \item last commit in 2014 ...
  \end{itemize}
\end{frame}

\begin{frame}[fragile,allowframebreaks]{JAVA API}
  \begin{itemize}
  \item \url{https://hadoop.apache.org/docs/current/hadoop-yarn/hadoop-yarn-site/WritingYarnApplications.html}
  \item Initialise and start
  \begin{lstlisting}
    YarnClient yarnClient = YarnClient.createYarnClient();
    yarnClient.init(conf);
    yarnClient.start();
  \end{lstlisting}
  \item Create an application, and get its application id.
    \begin{lstlisting}
      YarnClientApplication app = yarnClient.createApplication();
      GetNewApplicationResponse appResponse = app.getNewApplicationResponse();
    \end{lstlisting}
  \item \texttt{appResponse} contains information about the cluster
    such as the minimum/maximum resource capabilities of the cluster.

    \framebreak

  \item Setup process (a lot of lines ...)
    \begin{lstlisting}
      // set the application submission context
      ApplicationSubmissionContext appContext = app.getApplicationSubmissionContext();
      .....
    \end{lstlisting}
  \item Submit the application
    \begin{lstlisting}
      yarnClient.submitApplication(appContext);
    \end{lstlisting}
  \item and still a lot of things ...

  \item \url{https://hadoop.apache.org/docs/r2.4.1/api/index.html?org/apache/hadoop/yarn/client/api/YarnClient.html}
  \item \url{https://hadoop.apache.org/docs/r2.4.1/api/index.html?org/apache/hadoop/yarn/client/api/YarnClient.html}
  \end{itemize}
\end{frame}

\begin{frame}{Other APIs}
  \begin{itemize}
  \item \url{https://spring.io/guides/gs/yarn-basic/}
  \item \url{https://python-client-for-hadoop-yarn-api.readthedocs.io/en/latest/index.html}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{YARN Application}
  An example which works
  \url{https://github.com/blrunner/yarn-beginners-examples}
  \begin{exampleblock}{yarn jar target/nathalie-1.0-SNAPSHOT.jar com.labri.yarn.MyClient -jar target/nathalie-1.0-SNAPSHOT.jar}
    \tiny
\begin{verbatim}
INFO yarn.MyClient: Initializing Client
INFO yarn.MyClient: Running Client
INFO client.RMProxy: Connecting to ResourceManager at /0.0.0.0:8032
INFO conf.Configuration: resource-types.xml not found
INFO resource.ResourceUtils: Unable to find 'resource-types.xml'.
INFO yarn.MyClient: Max mem capabililty of resources in this cluster 8192
INFO yarn.MyClient: Max virtual cores capabililty of resources in this cluster 4
INFO yarn.MyClient: Application id application_1543827531035_0036
INFO yarn.MyClient: Application name com.labri.yarn.HelloYarn
INFO yarn.MyClient: Application queue default
INFO yarn.MyClient: Copy App Master jar from local filesystem and add to local environment
INFO yarn.MyClient: Set the environment for the application master
INFO yarn.MyClient: Setting up app master command
INFO yarn.MyClient: Completed setting up app master command {{JAVA_HOME}}/bin/java
        -Xmx10m com.labri.yarn.MyApplicationMaster --container_memory 10 --container_vcores 1
        --num_containers 1 --priority 0 1><LOG_DIR>/AppMaster.stdout 2><LOG_DIR>/AppMaster.stderr 
INFO yarn.MyClient: Submitting application to ASM
INFO impl.YarnClientImpl: Submitted application application_1543827531035_0036
INFO yarn.MyClient: Application has completed successfully.  Breaking monitoring loop : ApplicationId:36
INFO yarn.MyClient: Application completed successfully
\end{verbatim}
  \end{exampleblock}
\end{frame}


\begin{frame}[allowframebreaks]{Installing Hadoop-YARN on your laptop}
  \url{https://hadoop.apache.org/docs/r3.1.1/hadoop-project-dist/hadoop-common/SingleCluster.html}
  \begin{itemize}
  \item edit configuration files and set environment variables ...
  \item Start ResourceManager daemon and NodeManager daemon: \\
    \begin{exampleblock}{\$HADOOP\_HOME/sbin/start-yarn.sh}
      Starting resourcemanager\\
      Starting nodemanagers
    \end{exampleblock}
  \item Browse the web interface for the ResourceManager \url{http://localhost:8088/cluster}
    \includegraphics[width=\linewidth]{pictures/hadoop-cluster}
  \item Format the filesystem:
    \begin{exampleblock}{\$HADOOP\_HOME/bin/hdfs namenode -format}
      ...\\
      ... INFO namenode.FSImageFormatProtobuf: Saving image file /tmp/hadoop-nfurmento/dfs/name/current/fsimage.ckpt\_0000000000000000000 using no compression\\
      ... INFO namenode.FSImageFormatProtobuf: Image file /tmp/hadoop-nfurmento/dfs/name/current/fsimage.ckpt\_0000000000000000000 of size 394 bytes saved in 0 seconds .\\
      ... INFO namenode.NNStorageRetentionManager: Going to retain 1 images with txid $>=$ 0\\
    \end{exampleblock}
  \item Start NameNode daemon and DataNode daemon
    \begin{exampleblock}{\$HADOOP\_HOME/sbin/start-dfs.sh}
      Starting namenodes on [localhost]\\
      Starting datanodes\\
      Starting secondary namenodes [adrets]
    \end{exampleblock}
  \item Browse the web interface for the NameNode \url{http://localhost:9870}
    \includegraphics[width=\linewidth,height=4cm]{pictures/hadoop-nodemanager}
%    \framebreak
  \item Make HDFS directories
    \begin{exampleblock}{}
      hdfs dfs -mkdir /user \\
      hdfs dfs -mkdir /user/nfurmento \\
    \end{exampleblock}
    \begin{exampleblock}{hdfs dfs -ls /user}
      Found 1 items\\
      drwxr-xr-x   - nfurmento supergroup          0 2018-12-03 10:34  /user/nfurmento\\
    \end{exampleblock}
  \end{itemize}
\end{frame}

\begin{frame}[fragile,allowframebreaks]{Executing an application}
  \begin{itemize}
  \item Start the application
  \begin{exampleblock}{\tiny hadoop jar \$HADOOP\_HOME/share/hadoop/mapreduce/hadoop-mapreduce-examples-3.1.1.jar wordcount input output}
    \tiny
\begin{verbatim}
2018-12-03 10:36:02,908 INFO client.RMProxy: Connecting to ResourceManager at /0.0.0.0:8032
2018-12-03 10:36:03,135 INFO mapreduce.JobResourceUploader: Disabling
                Erasure Coding for path:  /tmp/hadoop-yarn/staging/nfurmento/.staging/job_1543827531035_0003
2018-12-03 10:36:03,268 INFO mapreduce.JobSubmitter: Cleaning up the staging area
                /tmp/hadoop-yarn/staging/nfurmento/.staging/job_1543827531035_0003
org.apache.hadoop.mapreduce.lib.input.InvalidInputException:
                Input path does not exist: hdfs://localhost:9000/user/nfurmento/input
\end{verbatim}
\end{exampleblock}
\item Copy the input files into the distributed filesystem:
\begin{exampleblock}{}
hdfs dfs -mkdir input \\
hdfs dfs -put \$HADOOP\_HOME/etc/hadoop/*.xml input
\end{exampleblock}
\item Start the application again ...
  \begin{exampleblock}{\tiny hadoop jar \$HADOOP\_HOME/share/hadoop/mapreduce/hadoop-mapreduce-examples-3.1.1.jar wordcount input output}
    \tiny
\begin{verbatim}
INFO client.RMProxy: Connecting to ResourceManager at /0.0.0.0:8032
INFO mapreduce.JobResourceUploader: Disabling Erasure Coding for path: /tmp/hadoop-yarn/staging/nfurmento/.staging/job_1543827531035_0006
INFO input.FileInputFormat: Total input files to process : 10
INFO mapreduce.JobSubmitter: number of splits:10
INFO Configuration.deprecation: yarn.resourcemanager.system-metrics-publisher.enabled is deprecated. Instead, use yarn.system-metrics-publisher.enabled
INFO mapreduce.JobSubmitter: Submitting tokens for job: job_1543827531035_0006
INFO mapreduce.JobSubmitter: Executing with tokens: []
INFO conf.Configuration: resource-types.xml not found
INFO resource.ResourceUtils: Unable to find 'resource-types.xml'.
INFO impl.YarnClientImpl: Submitted application application_1543827531035_0006
INFO mapreduce.Job: The url to track the job: http://adrets:8088/proxy/application_1543827531035_0006/
INFO mapreduce.Job: Running job: job_1543827531035_0006
INFO mapreduce.Job: Job job_1543827531035_0006 running in uber mode : false
INFO mapreduce.Job:  map 0% reduce 0%
INFO mapreduce.Job:  map 60% reduce 0%
INFO mapreduce.Job:  map 100% reduce 0%
INFO mapreduce.Job:  map 100% reduce 100%
INFO mapreduce.Job: Job job_1543827531035_0006 completed successfully
INFO mapreduce.Job: Counters: 54
\end{verbatim}
  \end{exampleblock}
  \begin{exampleblock}{}
    \tiny
\begin{verbatim}
File System Counters
    FILE: Number of bytes read=21836
    FILE: Number of bytes written=2401433
    FILE: Number of read operations=0
    FILE: Number of large read operations=0
    FILE: Number of write operations=0
    HDFS: Number of bytes read=29304
    HDFS: Number of bytes written=9749
    HDFS: Number of read operations=35
    HDFS: Number of large read operations=0
    HDFS: Number of write operations=2
Job Counters
    Killed map tasks=1
    Launched map tasks=10
    Launched reduce tasks=1
    Data-local map tasks=10
    Total time spent by all maps in occupied slots (ms)=39412
    Total time spent by all reduces in occupied slots (ms)=3560
    Total time spent by all map tasks (ms)=39412
    Total time spent by all reduce tasks (ms)=3560
    Total vcore-milliseconds taken by all map tasks=39412
    Total vcore-milliseconds taken by all reduce tasks=3560
    Total megabyte-milliseconds taken by all map tasks=40357888
    Total megabyte-milliseconds taken by all reduce tasks=3645440
\end{verbatim}
  \end{exampleblock}
  \begin{exampleblock}{}
    \tiny
\begin{verbatim}
Map-Reduce Framework
    Map input records=759
    Map output records=3075
    Map output bytes=38057
    Map output materialized bytes=21890
    Input split bytes=1231
    Combine input records=3075
    Combine output records=1305
    Reduce input groups=582
    Reduce shuffle bytes=21890
    Reduce input records=1305
    Reduce output records=582
    Spilled Records=2610
    Shuffled Maps =10
    Failed Shuffles=0
    Merged Map outputs=10
    GC time elapsed (ms)=2715
    CPU time spent (ms)=10200
    Physical memory (bytes) snapshot=3870781440
    Virtual memory (bytes) snapshot=28939984896
    Total committed heap usage (bytes)=4257218560
    Peak Map Physical memory (bytes)=393314304
    Peak Map Virtual memory (bytes)=2636603392
    Peak Reduce Physical memory (bytes)=218456064
    Peak Reduce Virtual memory (bytes)=2632486912
\end{verbatim}
  \end{exampleblock}
  \begin{exampleblock}{}
    \tiny
\begin{verbatim}
Shuffle Errors
    BAD_ID=0
    CONNECTION=0
    IO_ERROR=0
    WRONG_LENGTH=0
    WRONG_MAP=0
    WRONG_REDUCE=0
File Input Format Counters
    Bytes Read=28073
File Output Format Counters
    Bytes Written=9749
\end{verbatim}
  \end{exampleblock}
  \includegraphics[width=\linewidth]{pictures/hadoop-appli}
  \includegraphics[width=\linewidth]{pictures/hadoop-appli2}
\item get the output
  \begin{exampleblock}{hdfs dfs -get output output \&\& ls -s output}
    \tiny
    \begin{verbatim}
    12 part-r-00000   0 _SUCCESS
\end{verbatim}
  \end{exampleblock}
  \begin{exampleblock}{tail output/part-r-00000}
    \tiny
    \begin{verbatim}
when	3
which	10
while	1
who	3
will	12
with	29
work	1
writing,	10
you	11
zero	2
\end{verbatim}
  \end{exampleblock}
 \end{itemize}
\end{frame}

\begin{frame}[fragile,allowframebreaks]{Yarn CLI}
  \begin{itemize}
    \item List containers
      \begin{exampleblock}{yarn node -list -all}
        \tiny
        \begin{verbatim}
Total Nodes:1
         Node-Id	     Node-State	Node-Http-Address	Number-of-Running-Containers
    adrets:42069	        RUNNING	      adrets:8042	                           0
\end{verbatim}
      \end{exampleblock}
 \begin{exampleblock}{yarn node -list -all \% with application running}
        \tiny
        \begin{verbatim}
Total Nodes:1
         Node-Id	     Node-State	Node-Http-Address	Number-of-Running-Containers
    adrets:42069	        RUNNING	      adrets:8042	                           7
\end{verbatim}
 \end{exampleblock}
\item list applications
  \begin{exampleblock}{yarn app -list}
    \tiny
    \begin{verbatim}
Total number of applications (application-types: [], states: [SUBMITTED, ACCEPTED, RUNNING] and tags: []):1
Application-Id	                 Application-Name  Application-Type User       Queue    State	 Final-State  Progress  Tracking-URL
application_1543827531035_0008	 word count	   MAPREDUCE	    nfurmento  default	RUNNING	 UNDEFINED    5%	http://adrets:33179
\end{verbatim}
  \end{exampleblock}
\item print queue information
  \begin{exampleblock}{yarn queue -status default}
    \tiny
\begin{verbatim}
Queue Information :
Queue Name : default
    State : RUNNING
    Capacity : 100,0%
    Current Capacity : ,0%
    Maximum Capacity : 100,0%
    Default Node Label expression : <DEFAULT_PARTITION>
    Accessible Node Labels : *
    Preemption : disabled
    Intra-queue Preemption : disabled
\end{verbatim}
  \end{exampleblock}
  \end{itemize}
\end{frame}

\begin{frame}{Further reading}
  \begin{itemize}
    \item How YARN Changed Hadoop Job Scheduling
      \url{https://www.linuxjournal.com/content/how-yarn-changed-hadoop-job-scheduling}
    \item An Empirical Exploration of the Yarn in Big Data \url{https://www.researchgate.net/publication/321683158_An_Empirical_Exploration_of_the_Yarn_in_Big_Data}
  \end{itemize}
\end{frame}

\end{document}
